from ihs import compute_wihs
import re
import sys


if len(sys.argv)<3:
	posname='example.pos'
	genoname='example.geno'
else:
	posname=sys.argv[2]
	genoname=sys.argv[1]

f_pos=open(posname)
pos_lines=f_pos.readlines()
f_pos.close()

positions=[]

last_c=pos_lines[0].rstrip().split('\t')[0]

positions_chr=[]

indices_chr=[]

for i in xrange(len(pos_lines)):
	split=pos_lines[i].rstrip().split('\t')
	if split[0]!=last_c:
		positions.append(positions_chr)
		positions_chr=[]
		indices_chr.append(i)
	positions_chr.append(float(split[1]))
	last_c=split[0]
indices_chr.append(i+1)
positions.append(positions_chr)


f_geno=open(genoname)
lines=f_geno.readlines()
f_geno.close()

marker=[]

last_c=0
for c in indices_chr:
	marker_chr=[]

	for l in lines:
		split=re.split('\t',l.rstrip())
		if len(split)<2:
			continue

		marker_chr.append(map(int,split[last_c:c]))
	last_c=c
	marker.append(marker_chr)

wihs=compute_wihs(marker,positions)

f=open('wihs.out','w')
for i in xrange(len(wihs)):
	if wihs[i]==None:
		continue
	pos_split=re.split('\t',pos_lines[i].rstrip())
	f.write('%s\t%s\t%f\n' %(pos_split[0],pos_split[1],wihs[i]))
f.close()

		

